require 'httparty'

module Tumasms
	class Connection
		ENDPOINT = "http://tumasms.co.ke/ts/api"

		def initialize(user, pass)
			@user, @pass = user, pass
		end

		def get(url)
			HTTParty.post("#{ENDPOINT}#{url}", headers: headers)
		end

		def post(url, params)
			HTTParty.post("#{ENDPOINT}#{url}", body: params.merge(headers), headers: headers)
		end

		def put(url, params)
			HTTParty.put("#{ENDPOINT}#{url}", body: params.merge(headers), headers: headers)
		end

	private

		def headers
		  {api_key: @user, api_signature: @pass}
		end

	end
end
