require 'gyoku'

module Tumasms
	class Message < Tumasms::Connection

		# Takes in an array of recipients + their messages then BAM!
		# build_message & sends them VIA the deliver method call.
		# recipients is an Array of hashes containing:
		# 1. Recipient
		# 2. Message
		# 3. Sender
		# 4. ScheduledAt
		# [{recipient: "07100000", message: "Hey!", sender: "TUMASMS"},{}]

		def balance
			post("/get_balance", {})
		end
		alias_method :get_balance, :balance

		def deliver(recipients)
			post("/send_sms", prepare_recipients(recipients))
		end
		alias_method :send_sms, :deliver

	# private

		def prepare_recipients(recipients)
		  recipients_array = Array.new
			recipients.each { |recipient| recipients_array << build_message(recipient) }
			{messages: %{<request>#{recipients_array}</request>}}
		end

		# TODO: Check presence in RUBY
		def build_message(recipient)
			Gyoku.xml("sms!" => recipient_xml(recipient))
		end

		def recipient_xml(recipient)
			Gyoku.xml({
				recipient: recipient.fetch(:recipient, ""),
				message: recipient.fetch(:message, ""),
				sender: recipient.fetch(:sender, ""),
				scheduled_date: recipient.fetch(:scheduled_date, DateTime.now)
			},{key_converter: :none})
		end
	end
end
